Package org.eclipse.cdt.core.index

## Interface IIndexSymbols

    public interface IIndexSymbols

A container for symbols that should be added to a linkage in the persisted index. Contributors of the org.eclipse.cdt.core.PDOMASTProcessor extension-point are provided the opportunity to process the parsed AST translation units. Elements of interest are added to an implementation of this interface.

Since:
  5.6
Restriction:
  This interface is not intended to be implemented by clients.
Restriction:
  This interface is not intended to be extended by clients.

### Method Summary

All Methods Instance Methods Abstract Methods
`void` `add​(IASTPreprocessorIncludeStatement owner, IASTName name, IASTName caller)` Adds an IASTName along with an optional referencing IASTName to the map.
`void` `add​(IASTPreprocessorIncludeStatement owner, IASTPreprocessorIncludeStatement caller)` Creates an association from the caller include statement to the owning context.
`void` `add​(IASTPreprocessorIncludeStatement owner, IASTPreprocessorStatement caller)` Creates an association from the caller preprocessor statement to the owning context.
`boolean` `isEmpty()` Return true if the map contains no symbols and false otherwise.

### Method Detail

#### isEmpty

    boolean isEmpty()

Return true if the map contains no symbols and false otherwise.

#### add

    void add​(IASTPreprocessorIncludeStatement owner,
             IASTName name,
             IASTName caller)

Adds an IASTName along with an optional referencing IASTName to the map. The names will be associated with the optional owning include statement.

Parameters:
  `owner` - The optional include statement that provides context for the given names. Can be null.
  `name` - The name that is being added to the map, cannot be null.
  `caller` - The optional name that references the name being added. Can be null.

#### add

    void add​(IASTPreprocessorIncludeStatement owner,
             IASTPreprocessorIncludeStatement caller)

Creates an association from the caller include statement to the owning context.

#### add

    void add​(IASTPreprocessorIncludeStatement owner,
             IASTPreprocessorStatement caller)

Creates an association from the caller preprocessor statement to the owning context.